$ErrorActionPreference = 'Stop';

$packageName= 'azure-functions-core-tools'
$toolsDir   = "$(Split-Path -parent $MyInvocation.MyCommand.Definition)"
$url_x86        = 'https://functionscdn.azureedge.net/public/2.7.2184/Azure.Functions.Cli.win-x86.2.7.2184.zip'
$url_x64        = 'https://functionscdn.azureedge.net/public/2.7.2184/Azure.Functions.Cli.win-x64.2.7.2184.zip'
$checksum_x86   = '4C10E474287D9F115A2FB99FCACD701F1ACF891D09F02A3166377CFF11D51876DA63DA233A38F0AE10105AC0DD87660A56AED19BA15E2E7FBAA0C0BC5A9C8A6A'
$checksum_x64   = 'DD5D7C906D75D4B16C662BD3E8E2307CFAE58F21795668E56556A38B634BEAE670BBB894904EF9874A46B5819911E6B6A23493A23AECBB783C2AE2BE6DEDC813'

# By default, we want 32-bit installer
$url = $url_x86
$checksum = $checksum_x86

# If specifically asked for 64-bit, we use that
$pp = Get-PackageParameters
if ($pp['x64'] -eq 'true')
{
  $url = $url_x64
  $checksum = $checksum_x64
}

$packageArgs = @{
  packageName   = $packageName
  unzipLocation = $toolsDir
  url           = $url
  checksum      = $checksum
  checksumType  = 'SHA512'
}

Install-ChocolateyZipPackage @packageArgs

# only symlink for func.exe
$files = get-childitem $toolsDir -include *.exe -recurse
foreach ($file in $files) {
  if (!$file.Name.Equals("func.exe")) {
    #generate an ignore file
    New-Item "$file.ignore" -type file -force | Out-Null
  }
}

try {
  New-Item -type File -Path $toolsDir -Name "telemetryDefaultOn.sentinel" | Out-Null

  # show telemetry information
  ""
  "Telemetry"
  "---------"
  "The Azure Functions Core tools collect usage data in order to help us improve your experience."
  "The data is anonymous and doesn't include any user specific or personal information. The data is collected by Microsoft."
  ""
  "You can opt-out of telemetry by setting the FUNCTIONS_CORE_TOOLS_TELEMETRY_OPTOUT environment variable to '1' or 'true' using your favorite shell."
  ""
}
catch
{
  # That's ok
}
